# Netapp - a toolkit library for distributed software

Netapp is a Rust library that takes care of a few common tasks in distributed software:

- establishing secure connections
- managing connection lifetime, reconnecting on failure
- checking peer's state
- peer discovery
- query/response message passing model for communications
- multiplexing transfers over a connection
- overlay networks: full mesh or random peer sampling using Basalt
